<template>
  <v-row>
    <v-col>
      <v-form ref="form" v-model="valid" lazy-validation>
        <v-stepper v-model="step" vertical>
          <!-- Step 1: Delivery -->
          <v-stepper-step :complete="step > 1" step="1">
            Delivery
          </v-stepper-step>

          <v-stepper-content step="1">
            <v-radio-group v-model="model.address" :rules="requiredRules">
              <v-radio
                v-for="address in addresses"
                :key="address.toString()"
                :label="address.street"
                :value="JSON.stringify(address)"
              >
                <template #label>
                  <address-card :address="address"></address-card>
                </template>
              </v-radio>
            </v-radio-group>

            <v-textarea
              v-model="model.deliveryNotes"
              outlined
              clearable
              counter
              auto-grow
              rows="1"
              label="Delivery notes"
            ></v-textarea>

            <v-btn @click="$router.back()">Back</v-btn>
            <v-btn color="primary" :disabled="!addressChosen" @click="nextStep"
              >Continue</v-btn
            >
          </v-stepper-content>

          <!-- Step 2: Payment method -->
          <v-stepper-step :complete="step > 2" step="2">
            Payment method
          </v-stepper-step>

          <v-stepper-content step="2">
            <v-radio-group v-model="model.paymentMethod" :rules="requiredRules">
              <v-radio label="Cash on delivery" value="cash"></v-radio>
              <v-radio
                v-for="paymentMethod in wallet"
                :key="paymentMethod.toString()"
                :label="'**** **** **** ' + paymentMethod.cardNumber.slice(-4)"
                :value="JSON.stringify(paymentMethod)"
              >
                <template #label>
                  <payment-method-card
                    :payment-method="paymentMethod"
                  ></payment-method-card>
                </template>
              </v-radio>
            </v-radio-group>

            <v-btn @click="step--">Back</v-btn>
            <v-btn color="primary" :disabled="!paymentChosen" @click="nextStep"
              >Continue</v-btn
            >
          </v-stepper-content>

          <!-- Step 3: Order recap -->
          <v-stepper-step :complete="step > 3" step="3">
            Order recap
          </v-stepper-step>

          <v-stepper-content step="3">
            <order-recap class="mb-2" :order="order"></order-recap>

            <v-textarea
              v-model="model.orderNotes"
              outlined
              clearable
              counter
              auto-grow
              rows="1"
              label="Order notes"
            ></v-textarea>

            <v-btn @click="step--">Back</v-btn>
            <v-btn color="primary" @click="confirm">Confirm order</v-btn>
          </v-stepper-content>

          <!-- Step 4: Done! -->
          <v-stepper-step step="4">Done!</v-stepper-step>

          <v-stepper-content step="4">
            <h3>Your order is confirmed!</h3>
            <p>
              It is now waiting to be processed. You can track its progress in
              <nuxt-link to="/orders">your orders</nuxt-link>!
            </p>
            <v-btn color="primary" nuxt to="/">Go back to homepage</v-btn>
          </v-stepper-content>
        </v-stepper>
      </v-form>
    </v-col>
  </v-row>
</template>

<script lang="ts">
import Vue from 'vue'

export default Vue.extend({
  props: {
    cartItems: {
      type: Array,
      required: true,
    },
  },
  data() {
    return {
      step: 1,
      model: {
        address: '{}',
        deliveryNotes: '',
        paymentMethod: '{}',
        orderNotes: '',
      },
      valid: true,
      requiredRules: [
        (v: string) =>
          v === 'cash' ||
          (JSON.parse(v) && Object.keys(JSON.parse(v)).length > 0) ||
          'You must choose one',
      ],
      addresses: [
        {
          street: '1017, Chemin du Trastour',
          postalCode: '06330',
          city: 'Roquefort-les-pins',
          country: 'France',
        },
        {
          street: '1240, Route des Dolines',
          postalCode: '06560',
          city: 'Valbonne',
          country: 'France',
        },
      ],
      wallet: [
        {
          cardNumber: '1111222233334444',
          cardName: 'Nolan Amouyal',
          cardExpiration: {
            month: 5,
            year: 2025,
          },
          cardCrypto: 666,
        },
        {
          cardNumber: '5555666677778888',
          cardName: 'Alexis Georges',
          cardExpiration: {
            month: 7,
            year: 2023,
          },
          cardCrypto: 999,
        },
      ],
    }
  },
  computed: {
    order(): Object {
      return {
        model: this.model,
        items: this.cartItems,
      }
    },
    addressChosen(): boolean {
      const address = JSON.parse(this.model.address)

      return address && Object.keys(address).length > 0
    },
    paymentChosen(): boolean {
      if (this.model.paymentMethod === 'cash') return true

      const payment = JSON.parse(this.model.paymentMethod)

      return payment && Object.keys(payment).length > 0
    },
  },
  methods: {
    nextStep() {
      this.step++
    },
    confirm() {
      if ((this.$refs.form as any).validate()) {
        // TODO: AXIOS send order

        this.$store.commit('cart/clear')
        this.step++
      }
    },
  },
})
</script>
